﻿IF	OBJECT_ID('tempdb..#tmpViews') IS NOT NULL
		DROP TABLE #tmpViews

	CREATE TABLE #tmpViews ( ViewError VARCHAR(8000) )


Declare @strViewName as sysname, @strSQL as varchar(1000)
Declare curView Cursor FOR
select table_name as ViewName
From INFORMATION_SCHEMA.VIEWS

Open curView

Fetch Next from curView Into @strViewName

While (@@FETCH_STATUS = 0)
Begin
Print @strViewName + ' will be refreshed now'
Set @strSQL = 'exec sp_refreshview ' + @strViewName
BEGIN TRY
	begin tran
	exec (@strSQL)
	commit
END TRY
BEGIN CATCH
	rollback
    -- Execute error retrieval routine.
    Insert #tmpViews (ViewError) VALUES(@strViewName+':'+ERROR_MESSAGE()) 
END CATCH;


Fetch Next from curView Into @strViewName
End

Close curView
Deallocate curView
SELECT * FROM #tmpViews

IF	OBJECT_ID('tempdb..#tmpViews') IS NOT NULL
		DROP TABLE #tmpViews


GO
